/* This file is part of smf.
   Copyright (C) 2006, 2007, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#ifndef __SMAP_OSTR_H
#define __SMAP_OSTR_H

/* ostr.c */
#include <unistd.h>
#include <stdarg.h>

typedef struct smap_output_stream *smap_ostream_t;
int smap_ostream_write(smap_ostream_t str, const char *buf, size_t len);
int smap_ostream_vprintf(smap_ostream_t str, const char *fmt, va_list ap);
int smap_ostream_printf(smap_ostream_t str, const char *fmt, ...);
int smap_ostream_flush(smap_ostream_t str);
smap_ostream_t smap_ostream_create(void (*flush)(void *data, char *buf),
				   void *data);
void smap_ostream_free(smap_ostream_t str);
void smap_ostream_destroy(smap_ostream_t *str);

#endif
